unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,softrender, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);

    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;


  const xw=800;
  xh=600;

implementation

{$R *.dfm}


type TRGB32=packed record
                    B:BYTE;
                    G:BYTE;
                    R:BYTE;
                    A:BYTE;
                   end;

var BitmapInfo: TBITMAPINFO;




procedure TForm1.FormCreate(Sender: TObject);
var p:array[0..5] of TVect;
var i,j:integer;
begin







   ZeroMemory(@BitmapInfo, sizeof(BitmapInfo));
   BitMapInfo.bmiHeader.biSize:=SizeOf(TBitmapInfo);
   BitMapInfo.bmiHeader.biWidth:=xw;
   BitMapInfo.bmiHeader.biHeight:=xh;
   BitMapInfo.bmiHeader.biBitCount:=32;
   BitMapInfo.bmiHeader.biPlanes:=1;
   BitMapInfo.bmiHeader.biCompression:=BI_RGB;
   BitMapInfo.bmiHeader.biSizeImage:=xw*xh*4;





   viewport.arr[0]:=0;
   viewport.arr[1]:=0;
   viewport.arr[2]:=xw;
   viewport.arr[3]:=xh;
   _gluPerspective(45,
                  xw / xh,
                  1, 1000);





  LoadTex('wall.jpg');
  LoadTex('height.jpg');


 BufferSetDim(xw,xh);


 p[0]:=Vector(0,0,-1);
 p[1]:=Vector(5,0,-1);
 p[2]:=Vector(5,5,-1);
 p[3]:=Vector(0,0,1);
 p[4]:=Vector(0,0,1);
 p[5]:=Vector(0,0,1);
 Poly(p,1,uv(0,0,1,0,1,1));

 p[0]:=Vector(0,0,-1);
 p[1]:=Vector(0,5,-1);
 p[2]:=Vector(5,5,-1);
 p[3]:=Vector(0,0,1);
 p[4]:=Vector(0,0,1);
 p[5]:=Vector(0,0,1);
 Poly(p,0,uv(0,0,0,1,1,1));


 for i := 0 to 50-1 do
  begin

 p[0]:=Vector(0,0,-5-i);
 p[1]:=Vector(5,0,-5-i);
 p[2]:=Vector(5,5,-5-i);
 p[3]:=Vector(0,0,1);
 p[4]:=Vector(0,0,1);
 p[5]:=Vector(0,0,1);
 Poly(p,1,uv(0,0,1,0,1,1));

 p[0]:=Vector(0,0,-5-i);
 p[1]:=Vector(0,5,-5-i);
 p[2]:=Vector(5,5,-5-i);
 p[3]:=Vector(0,0,1);
 p[4]:=Vector(0,0,1);
 p[5]:=Vector(0,0,1);
 Poly(p,0,uv(0,0,0,1,1,1));
  end;

//showmessage(floattostr(norms[1].z));
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var gettickcount2:integer;
var i,j,k:integer;
var oldtime:integer;
var time:integer;
var fps:integer;
var ccc:TRGB32;
var cnt:integer;
clr:TColor;
begin
timer1.Enabled:=false;
//Rasterize2;

{SetPixelAsm(5,5,1255);
clr:=GetPixelAsm(5,5);
showmessage(inttostr(clr));    }

cnt:=20;

repeat

 oldtime:=time;

 for k := 0 to cnt - 1 do
  begin

_gluMakeIdentity(matMod);


{
   dxuLookAt(0,0,6,
            0, 0, 0,
            0, 1, 0);
 }


 gettickcount2:= gettickcount;

 camera.x:=10*cos(gettickcount2/10000);
 camera.y:=0;
 camera.z:=10*sin(gettickcount2/10000);

 {
 camera.x:=0;
 camera.y:=0;
 camera.z:=5;
  }


 dxuLookAt(camera.x,camera.y,camera.z,
            0, 0, 0,
            0, 1, 0);

dxTranslatef (-2.5,-2.5,0);

 BufferLock;


 for i := 0 to 100-1 do
Polygon(i);


 rasterize;


 BufferUnLock;



SetDIbitstoDevice(Canvas.Handle,
                  0,
                  0,
                  xw,
                  xh,
                  0,
                  0,
                  0,
                  xh,
                  BackBuffer.FrameBuffer,
                  BitmapInfo,
                  DIB_RGB_COLORS);




{
for i := 0 to BackBuffer._w - 1 do
 for j := 0 to BackBuffer._h - 1 do
  SetPixelAsm(i,j,rgba(0,0,255,0));
 }

 FillChar(BackBuffer.FrameBuffer^,xw*xh*4,0);

  end;



   
   

time:=gettickcount;
 if time-oldtime<>0 then

 fps:=round(cnt*1000/(time-oldtime));

Form1.Caption:='tmtlib Engine v0.2 Software rendering 100 polygons. FPS='+inttostr(fps)+' xcount='+inttostr(xcount)+' '+inttostr(xc2);

application.ProcessMessages;
until false;



 end;






end.
